

version (Windows) {
  import std.c.windows.windows;
  import std.string;
  
  extern (Windows) {
    BOOL SHGetSpecialFolderPathA(HWND, LPTSTR, int, BOOL);
  }

  char[] homedir()
  {
    char[] homedir = new char[MAX_PATH];
    
    BOOL retval = SHGetSpecialFolderPathA(null,
                                          cast(char*)homedir,
                                          0x1a, 0);
    if (retval == FALSE)
      throw new Error("cannot access application directory");
    
    return toString(cast(char*)homedir);
  }
} else {
  import std.c.stdlib;
  import std.string;
  
  char[] homedir()
  {
    return toString(getenv(toStringz("HOME")));
  }
}

import std.path;

char[] score_filename()
{
  return std.path.join(homedir(), ".pencil-bullet-score");
}

debug(GetFolder) {
  import std.cstream;
  import std.utf;
  
  int main(char[][] args)
  {
    size_t idx = 0;
    dout.writeLine(homedir());
    dout.writeLine(score_filename());
    while (idx < score_filename.length) {
      dout.writefln("%d\n", score_filename[idx]);
      decode(score_filename, idx);
    }
    return 0;
  }
}
  
